#version 120

varying vec4 texcoord;
varying vec3 sunlight;
varying vec3 lightVector;
varying vec3 ambient_color;

uniform int worldTime;
uniform float rainStrength;
uniform vec3 sunPosition;
uniform vec3 moonPosition;

	const ivec4 ToD[25] = ivec4[25](ivec4(0,3.0,14.0,40.0), //hour,r,g,b
							ivec4(1,3.0,14.0,40.0),
							ivec4(2,3.0,14.0,40.0),
							ivec4(3,3.0,14.0,40.0),
							ivec4(4,3.0,14.0,40.0),
							ivec4(5,3.0,14.0,40.0),
							ivec4(6,200,45,5),
							ivec4(7,200,45,5),
							ivec4(8,200,45,5),
							ivec4(9,170,45,5),
							ivec4(10,170,45,5),
							ivec4(11,180,40,5),
							ivec4(12,190,40,5),
							ivec4(13,180,40,5),
							ivec4(14,170,45,5),
							ivec4(15,170,45,5),
							ivec4(16,200,45,5),
							ivec4(17,200,45,5),
							ivec4(18,200,45,5),
							ivec4(19,3.0,14.0,40.0),
							ivec4(20,3.0,14.0,40.0),
							ivec4(21,3.0,14.0,40.0),
							ivec4(22,3.0,14.0,40.0),
							ivec4(23,3.0,14.0,40.0),
							ivec4(24,3.0,14.0,40.0));

							
							
	////////////////////ambient color////////////////////
	////////////////////ambient color////////////////////
	////////////////////ambient color////////////////////
	const ivec4 ToD2[25] = ivec4[25](ivec4(0,45,60,140), //hour,r,g,b
							ivec4(1,45,60,140),
							ivec4(2,45,60,140),
							ivec4(3,45,60,140),
							ivec4(4,45,60,140),
							ivec4(5,45,60,140),
							ivec4(6,110,100,130),
							ivec4(7,110,100,130),
							ivec4(8,110,100,130),
							ivec4(9,110,100,130),
							ivec4(10,110,100,130),
							ivec4(11,110,100,130),
							ivec4(12,110,100,130),
							ivec4(13,110,100,130),
							ivec4(14,110,100,130),
							ivec4(15,110,100,130),
							ivec4(16,110,100,130),
							ivec4(17,110,100,130),
							ivec4(18,110,100,130),
							ivec4(19,45,60,140),
							ivec4(20,45,60,140),
							ivec4(21,45,60,140),
							ivec4(22,45,60,140),
							ivec4(23,45,60,140),
							ivec4(24,45,60,140));
							
							
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////

void main() {
	
		if (worldTime < 12700 || worldTime > 23250) {
		lightVector = normalize(sunPosition);
	}
	
	else {
		lightVector = normalize(moonPosition);
	}
	
	gl_Position = ftransform();
	
	texcoord = gl_MultiTexCoord0;
	
	//sunlight color
	float hour = worldTime/1000.0+6.0;
	if (hour > 24.0) hour = hour - 24.0;

							
	ivec4 temp = ToD[int(floor(hour))];
	ivec4 temp2 = ToD[int(floor(hour)) + 1];
	
	sunlight = mix(vec3(temp.yzw),vec3(temp2.yzw),(hour-float(temp.x))/float(temp2.x-temp.x))/255.0f;
	
	
	ivec4 tempa = ToD2[int(floor(hour))];
	ivec4 tempa2 = ToD2[int(floor(hour)) + 1];
	
	ambient_color = mix(vec3(tempa.yzw),vec3(tempa2.yzw),(hour-float(tempa.x))/float(tempa2.x-tempa.x))/255.0f;

	
}
