#version 120


varying vec4 texcoord;
varying vec3 sunlight;

uniform int worldTime;
uniform float rainStrength;

	const ivec4 ToD[25] = ivec4[25](ivec4(0,200,134,48), //hour,r,g,b
								ivec4(1,200,134,48),
								ivec4(2,200,134,48),
								ivec4(3,200,134,48),
								ivec4(4,200,134,48),
								ivec4(5,200,134,48),
								ivec4(6,200,153,60),
								ivec4(7,200,166,72),
								ivec4(8,200,175,84),
								ivec4(9,200,183,96),
								ivec4(10,2200,189,108),
								ivec4(11,2200,195,120),
								ivec4(12,2200,200,132),
								ivec4(13,2200,195,120),
								ivec4(14,2200,189,108),
								ivec4(15,2200,183,96),
								ivec4(16,2200,175,84),
								ivec4(17,2200,166,72),
								ivec4(18,200,153,60),
								ivec4(19,200,134,48),
								ivec4(20,200,134,48),
								ivec4(21,200,134,48),
								ivec4(22,200,134,48),
								ivec4(23,200,134,48),
								ivec4(24,200,134,48));

////////////////////ambient color////////////////////
////////////////////ambient color////////////////////
////////////////////ambient color////////////////////
const ivec4 ToD2[25] = ivec4[25](ivec4(0,8,20,30), //hour,r,g,b
								ivec4(1,8,20,30),
								ivec4(2,8,20,30),
								ivec4(3,8,20,30),
								ivec4(4,8,20,30),
								ivec4(5,30,75,150),
								ivec4(6,60,160,255),
								ivec4(7,60,160,255),
								ivec4(8,60,160,255),
								ivec4(9,660,160,255),
								ivec4(10,660,160,255),
								ivec4(11,660,160,255),
								ivec4(12,660,160,255),
								ivec4(13,660,160,255),
								ivec4(14,660,160,255),
								ivec4(15,660,160,255),
								ivec4(16,660,160,255),
								ivec4(17,660,160,255),
								ivec4(18,660,160,255),
								ivec4(19,30,75,150),
								ivec4(20,8,20,30),
								ivec4(21,8,20,30),
								ivec4(22,8,20,30),
								ivec4(23,8,20,30),
								ivec4(24,8,20,30));
								
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////

void main() {
	
	gl_Position = ftransform();
	
	texcoord = gl_MultiTexCoord0;
	
	//sunlight color
	float hour = worldTime/1000.0+6.0;
	if (hour > 24.0) hour = hour - 24.0;

							
	ivec4 temp = ToD[int(floor(hour))];
	ivec4 temp2 = ToD[int(floor(hour)) + 1];
	
	sunlight= mix(vec3(temp.yzw),vec3(temp2.yzw),(hour-float(temp.x))/float(temp2.x-temp.x))/255.0f;
}
